//coded by Feifei Li, contact: lifeifei@cs.fsu.edu

#include "udb.h"
#include "mtimer.h"

bool rank_xtuple(XTuple t1, XTuple t2)
{
	return t1.prank<t2.prank;
}


int main(int argc, char **argv)
{
	if (argc!=5)
	{
		cout<<"Usage: "<<argv[0]<<" input_file "<<" m(0 to read all) "<<" k(0 to rank all) "<<" showRes(0,1)"<<endl;
		return -1;
	}
    
	unsigned int m=atoi(argv[2]);
	unsigned int k=atoi(argv[3]);
	int showRes=atoi(argv[4]);

	Udb db(0, argv[1]);
	db.readRecords(m);
	vector<XTuple> xrank;
	MTimer timer;

	timer.go();	
	for (unsigned int i=0;i<db.N;i++)
	{
		for (unsigned int j=0;j<db.N;j++)
		{
			if (j==i)
				continue;
			db.xtps[i].prank+=db.xtps[i].rank(db.xtps[j]);
		}
		//reuse the xtuple class to represent the ranking information
		XTuple xr(i, 0, 0, 0, db.xtps[i].prank);
		xrank.push_back(xr);
	}	

	sort(xrank.begin(), xrank.end(),rank_xtuple);
	timer.stop();
	timer.update();

	vector<unsigned int> rankpos;	
	if (k==0)
		k=db.N;
	for (unsigned int i=0;i<k;i++)
		rankpos.push_back(xrank[i].id);
     
	if (showRes==1)
	{
        	db.printXTuples(rankpos);
		//cout<<endl<<"UDB with Top-k= "<<k<<" x-ranked of xtuples "<<endl;
    	}
	else
	{
	  cout<<k<<" "<<db.N<<" "<<db.hist.size()<<" ";
	  timer.printStat();
	  cout<<endl;
	}
    return 1;	
}
