//coded by Feifei Li, contact: lifeifei@cs.bu.edu

#include "xtuple.h"
#include <stdio.h>
#include <stdlib.h>

ostream & operator<<( ostream &os, XTuple &xtp ) 
{ 
  //os<< xtp.id << " "<< xtp.xdegree<< " "<<xtp.expvalue << " "<<xtp.var<< " "<<xtp.prank<<" "<<xtp.prankL<<" "<<xtp.prankH;
	//for (int i=0;i<xtp.xdegree;i++)
	  //os<< " " << xtp.tuples[i];
	//os<<endl;
  os<< xtp.id<<" "<<xtp.prank<<endl;
        return ( os ); 
}

XTuple::XTuple()
{
   this->id=0;
   this->xdegree=0;
   this->expvalue=0.0;
   this->var=0.0;
   this->prank=0.0;
   this->markv=0.0;
   this->chevFirst=true;
   this->chev=0.0;
   this->prankL=0.0;
   this->prankH=0.0;
}

XTuple::XTuple(unsigned int id, int xdegree, double expvalue, double var, double prank)
{
   this->id=id;
   this->xdegree=xdegree;        
   this->expvalue=expvalue;
   this->var=var;
   this->prank=prank;
   this->markv=0.0; 
   this->chev=0.0;
   this->chevFirst=true;
   this->prankL=0.0;
   this->prankH=0.0;
}


XTuple::XTuple(unsigned int id, int xdegree, double expvalue, double var, double prank, double prankL, double prankH)
{
   this->id=id;
   this->xdegree=xdegree;        
   this->expvalue=expvalue;
   this->var=var;
   this->prank=prank;
   this->markv=0.0;
   this->chev=0.0;
   this->chevFirst=true;
   this->prankL=prankL;
   this->prankH=prankH;
}

XTuple::XTuple(const XTuple& xtp)
{
   this->id=xtp.id;
   this->xdegree=xtp.xdegree;        
   this->tuples=xtp.tuples;
   this->expvalue=xtp.expvalue;
   this->var=xtp.var;
   this->prank=xtp.prank;
   this->markv=xtp.markv;
   this->chev=xtp.chev;
   this->chevFirst=xtp.chevFirst;
   this->prankL=xtp.prankL;
   this->prankH=xtp.prankH;
}

XTuple::~XTuple()
{
  tuples.clear();
}

unsigned int XTuple::size()
{
  unsigned int k=(unsigned int)tuples.size();
  return k*(Tuple::size())+8;

      //4 bytes for the id
      // return xdegree*Tuple.size()+4; //fixed xdegree case
}

double XTuple::rank(XTuple tpj)
{
	double r=0.0;
	for (int i=0;i<xdegree;i++)
	{
		for (int j=0;j<tpj.xdegree;j++)
		{
			if (tpj.tuples[j].value>tuples[i].value)
				r+=tuples[i].confidence*tpj.tuples[j].confidence;
		}
	}
	return r;
}

double XTuple::markov(double Xn)
{
  double r=0.0;
  for (int i=0; i<xdegree;i++) { 
    if (Xn>=tuples[i].value)
      r=r+tuples[i].confidence;
    else
      r=r+tuples[i].confidence*(Xn/tuples[i].value);
    if (r>=1.0) {
      r=1.0;
      break;
    }
  }
  return r;
}

