%coded by Feifei Li, contact: lifeifei@cs.bu.edu

function [udb] = uzipf( N, m, numxtuple, xdegree, a)

score = rand(N, 1);
score(:, 1)=ceil(score(:,1)*m);
confidence = randraw('zipf', a, N);
A=unique(confidence);
h=hist(confidence, A);
h=h';
for i=1:N
    c=find(A(:)==confidence(i));
    confidence(i)=h(c)/N;
end

X=[score, confidence];

id = [1:N];
id = id';
X=sortrows(X, [-1 -2]);
udb=[id, X(:,1), X(:,2)];

xtuplefile=sprintf('xid_%d_m%d_a%1.2f_%d_%d',N,m,a,numxtuple,xdegree);
udb=gen_xtuple(udb, N, numxtuple, xdegree, xtuplefile);

output=sprintf('xtuple_%d_m%d_a%1.2f_%d_%d',N,m,a,numxtuple,xdegree);
fid = fopen(output, 'wt');
fprintf(fid, '%u %e %1.4f\n', udb');
fclose(fid);
