//coded by Feifei Li, contact: lifeifei@cs.fsu.edu

#include "udb.h"
#include <queue>
#include <sys/param.h>
#include <sys/types.h>
#include <map>
#include <ext/hash_map>
#include <ext/hash_fun.h>
#include <cstring>


using namespace::std;

class GnuHash
{
public:
	size_t operator()(const unsigned int& x) const
	{
		__gnu_cxx::hash<const char*> H;
		char bits[4];
		memcpy(bits, &x, 4);
		return H(bits);
	}
};


class MedianRank {
	public:
    MedianRank(int k);
    ~MedianRank(); 
    bool initDB(unsigned int N, char* input_file, char* xtuple_file, int xdegree, unsigned int numxtuple);
    void findTopk();
	bool checkTerminate(vector<double> krank, vector<double>Rij);
	void printTopk();
	bool has_preceeding_alternative(unsigned int tp_sortid);
	void test_hashmap(__gnu_cxx::hash_map<unsigned int, unsigned int, GnuHash> mp);
	void computeRij(vector<double> pi, vector<double>& rij);
	void printStatistics();
	void getMemsize();

	public:
	int k;
	unsigned int n;
	Udb* db;
	struct tms st,ed;
	struct timeval tdiff, start, end;
	double t1, t2;
	double elapsed;
	double usertime;
	double systemtime;
	double realtime;
	unsigned long memusage;

	vector<double> Rij;
	vector<Tuple> topk;
	vector<double> krank;
	vector<double> barp;
	__gnu_cxx::hash_map<unsigned int, unsigned int, GnuHash> barp_location;
};
