//coded by Feifei Li, contact: lifeifei@cs.bu.edu

#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <string>
#include "tuple.h"
#include <vector>
#include <sys/time.h>
#include <sys/times.h>
#include <ext/hash_map>
#include <ext/hash_fun.h>


using namespace::std;


class Udb {
	public:
    Udb(unsigned int N, char* input_file);
    ~Udb(); 
    bool readRecords();
    void sortByScore();
    void printDB();
    unsigned int buildXtuples(char* file_input, int xdegree, unsigned int numxtuple);
    void printXtuple(unsigned int id); //only call this function after buildXtuple
    void printXtuple(); //only call this function after buildXtuple
    void buildqi();
    void getRankDist();
    void printRankDist();

	public:
	unsigned int N;
	unsigned int numxtuple;
	int xdegree;
	std::ifstream fin;
	vector<Tuple> tuples;
	vector< vector<unsigned int> > xtuples;
        vector<unsigned int> preceding_xtuples; // xtuples preceding a current tuple, contains xid's
        vector<double> merged_tuples;  // indexable by xid
	vector<double> qi;
	__gnu_cxx::hash_map<unsigned long, unsigned int> hist;
	double ts;
};
